using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using System.Data;

namespace TestGrid
{
    public class TestClass
    {
        private int accountID;
        private string number = "";
        private TestCollection children = new TestCollection();


        public TestClass()
        { }


        public int AccountID
        {
            get
            {
                return accountID;
            }
            set
            {
                accountID = value;
            }
        }


        public string Number
        {
            get
            {
                return number;
            }
            set
            {
                number = value;
            }
        }

       
        public TestCollection SubAccounts
        {
            get
            {
                return children;
            }
            set
            {
                children = value;
            }
        }

    }

    public class TestCollection : CollectionBase
    {
        public int Add(TestClass testclass)
        {
            return List.Add(testclass);
        }
        public void Insert(int index, TestClass testclass)
        {
            List.Insert(index, testclass);
        }
        public void Remove(TestClass testclass)
        {
            List.Remove(testclass);
        }
        public bool Contains(TestClass testclass)
        {
            return List.Contains(testclass);
        }
        public int IndexOf(TestClass testclass)
        {
            return List.IndexOf(testclass);
        }
        public void CopyTo(TestClass[] array, int index)
        {
            List.CopyTo(array, index);
        }
        public TestClass this[int index]
        {
            get { return (TestClass)List[index]; }
            set { List[index] = value; }
        }

        public void CreateCollection()
        {
            TestClass account00 = new TestClass();
            account00.Number = "00";
            account00.AccountID = 0;
            List.Add(account00);

            //dummy kid
            TestClass account00Child = new TestClass();
            account00Child.Number = "00-child";
            account00Child.AccountID = -1;
            account00.SubAccounts.Add(account00Child);


            TestClass account = new TestClass();
            account.Number = "1";
            account.AccountID = 1;
            List.Add(account);

            //find kids
            TestClass account1 = new TestClass();
            account1.Number = "11";
            account1.AccountID = 2;
            account.SubAccounts.Add(account1);


            TestClass account2 = new TestClass();
            account2.Number = "111";
            account2.AccountID = 3;
            account1.SubAccounts.Add(account2);


            TestClass account3 = new TestClass();
            account3.Number = "1111";
            account3.AccountID = 4;
            account2.SubAccounts.Add(account3);



            TestClass account4 = new TestClass();
            account4.Number = "11111";
            account4.AccountID = 5;
            account3.SubAccounts.Add(account4);


            TestClass account5 = new TestClass();
            account5.Number = "111111";
            account5.AccountID = 6;
            account4.SubAccounts.Add(account5);



        }
    
        

     
    

    }
}
